% Program projekt filtrow nierekursywnych;
clear all;close all;
numR21=0.4*sinc(0.4*(-10:10));[ampR21,w]=freqz(numR21,1,512,2);
fiR21=(180/pi)*angle(ampR21);
numR51=0.4*sinc(0.4*(-25:25));[ampR51,w]=freqz(numR51,1,512,2);
fiR51=(180/pi)*angle(ampR51);
numH21=numR21.*hamming(21)';[ampH21,w]=freqz(numH21,1,512,2);
numH51=numR51.*hamming(51)';[ampH51,w]=freqz(numH51,1,512,2);
C='ymcrgbw';c=1;
while 1;
while 1;
while 1;
s=menu('PROGRAM CWICZENIA','Wprowadzenie','Projekt filtru nierekursywnego','Koniec');
if s==3;break;end;
while 1;
if s==2;break;end;
while 1;
sp=menu('Filtry SOI','1.DolnoPrzepustowe z oknem prostokatnym','2.Transformacje','3.Modyfikacja oknem Hamminga','4.Koniec');
if sp==4;break;end;
while 1; 
if sp==3;break;end;
while 1;
if sp==2;break;end;
menu('Wsp. filtru h(n) = 2fc*sinc(2fc*n); fc < fp/2','Dalej');
subplot(2,1,1);
x=[0 0.4 0.401 1];y=[1 1 0 0];plot(x,y,'r');hold on;
plot(w,abs(ampR21),w,abs(ampR51));
text(0.3,1.2,'21');text(0.38,1.2,'51');text(0.42,0.9,'ideal.');text(0.98,0.1,'k');
ylabel('Amplituda');xlabel('czestotliwosc k*fp/2, k<1');grid;
title('Filtr dolnoprzep.- okno prostokatne N=21 i N=51');
subplot(2,1,2);
plot(w,fiR21,w,fiR51);
ylabel('Faza [stopnie]');xlabel('Czestotliwosc - j.w.');grid;
menu('Odpowiedz impulsowa','Dalej');
close;
impz(numR21);grid;title('Odpowiedz impulsowa filtru - N=21');
xlabel('Numer probki');ylabel('Amplituda (wspolcz. filtru)')
text(19,0.01,'m');
menu('Dalej','Dalej');
close;
impz(numR51);grid;title('Odpowiedz impulsowa filtru - N=51');
xlabel('Numer probki');ylabel('Amplituda (wspolcz. filtru)')
text(48,-0.09,'m');
menu('Nastepna opcja','O.K.');
close;
break;
end;
if sp==1;break;end;
% Transformacje
menu('Filtr gornoprzepustowy','fg=fp/2 - fgdp; h(m)=(-1)^m*hdp(m);','Dalej');
for k=1:21;hgp(k)=(-1)^(k-1)*numR21(k);end;
[H,v]=freqz(hgp,1,512,2);
subplot(2,1,1);
plot(x,y,'r');hold on;
plot(w,abs(ampR21),v,abs(H));grid;
title('Transformacja filtru DP w GP; N=21');
ylabel('Amplituda');xlabel('czestotliwosc k*fp/2, k<1');
text(0.3,1.2,'DP');text(0.7,1.2,'GP');
a=[0 0.6 0.601 1];b=[0 0 1 1];
plot(a,b,'g');
hold off;
subplot(2,1,2);
plot(v,(180/pi)*angle(H));grid;
title('Faza filtru GP');
ylabel('Faza [stopnie]');xlabel('Czestotliwosc - j.w.');
menu('Odpowiedz impulsowa filtru GP; N=21','Dalej');
subplot(2,1,1);
impz(numR21);grid;
title('Odpowiedz impulsowa filtru DP');
xlabel('Numer probki');ylabel('Amplituda (wspolcz. filtru)')
text(19,0.-0.13,'m');
subplot(2,1,2);
impz(hgp);grid;
title('Odpowiedz impulsowa filtru GP');
xlabel('Numer probki');ylabel('Amplituda (wspolcz. filtru)');
text(19,-0.43,'m');
menu('Filtr SrodkowoPrzepustowy; N=21','hsp(m)=2cos(2pi*m*fo)*hdp(m); f1=fo-fdp;f2=fo+fdp','Dalej');
for k=1:21;hsp(k)=2*cos(0.5*pi*(k-1))*numR21(k);end;
[H,v]=freqz(hsp,1,512,2);
subplot(2,1,1);
plot(x,y,'r');hold on;
plot(v,abs(H));grid;
title('Transformacja filtru DP w SP; N=21');
ylabel('Amplituda');xlabel('czestotliwosc k*fp/2, k<1');
hold off;
subplot(2,1,2);
plot(v,(180/pi)*angle(H));grid;
title('Faza filtru SP');
ylabel('Faza [stopnie]');xlabel('Czestotliwosc - j.w.');
menu('Odpowiedz impulsowa filtru SP; N=21','Dalej');
subplot(2,1,1);
impz(numR21);grid;
title('Odpowiedz impulsowa filtru DP');
xlabel('Numer probki');ylabel('Amplituda (wspolcz. filtru)');
text(19,0.-0.13,'m');
subplot(2,1,2);
impz(hsp);grid;
title('Odpowiedz impulsowa filtru SP');
xlabel('Numer probki');ylabel('Amplituda  (wspolcz. filtru)');
text(19,-0.9,'m');

menu('Nastepna opcja','O.K.');
close;
break;
end;
while 1;
if sp==1;break;end;
if sp==2;break;end;
% Hamming
menu('Okno Hamminga','Dalej');
subplot(2,1,1);
impz(hamming(21));
title('Okno Hamminga N=21');text(19,-0.1,'m');grid;
ylabel('Wspolcz.modyfikujace');
subplot(2,1,2);
impz(hamming(51));grid;text(48,-0.1,'m');
title('Okno Hamminga N=51');
ylabel('Wspolcz.modyfikujace');
menu('Charakterystyki czestotliwosciowe','Dalej');
subplot(2,1,1);
plot(x,y,'r');hold on;
plot(w,abs(ampR21),w,abs(ampH21));
text(0.32,1.2,'PR');text(0.32,0.7,'H');text(0.95,0.1,'k');text(0.82,1.2,'N=21');
ylabel('Amplituda');xlabel('Czestotliwosc k*fp/2,  k<1');grid;
title('Filtry DP.-okno prostokatne (PR),modyfikowane oknem Hamminga (H)');
subplot(2,1,2);
plot(w,abs(ampR51),w,abs(ampH51));grid;
ylabel('Amplituda');xlabel('Czestotliwosc j.w.');
text(0.34,1.2,'PR');text(0.34,0.7,'H');
menu('Nastepna opcja','O.K.');
close;
break;
end;
end;
break;
end;
if s==2;break;end;
end;
if s==3;break;end;

% TUTAJ PROJEKT;

while 1;
spr1=menu('Etapy projektu','Badanie filtru ju zaprojektowanego','Projekt przez dyskretyzacj zaoonej ch-styki czst.(FFT)');
if spr1==2;break;end;
home;disp('ZADANIE');
disp('W zbiorze funkcji programu s dwa okna:');
disp(' - okno kosinusoidalne wcos(fo,fp)');
disp(' - okno sinusoidalne wsin(fo,fp)');
disp(' - fo, fp - odpowiednio czstotliwosc odpowiadajaca okresowi o dugoci');
disp('            okna i czstotliwo prbkowania w Hz.');disp(' ');
disp('Zbadaj waciwoci filtrw o takich oknach wykonujc kolejno "z rki"');
disp('nastpujce komendy:');disp(' ');
disp('fo=50;fp=1000;    (na przykad)');
disp('hc=wcos(fo,fp)');
disp('[ampHc,f]=freqz(hc,1,512,fp);');
disp('hs=wsin(fo,fp)');
disp('[ampHs,f]=freqz(hs,1,512,fp);');
disp('plot(f,abs(ampHc),f,abs(ampHs));');
disp('plot(f,(180/pi)*angle(hc),f,(180/pi)*angle(hs);');
disp(' ');disp('Zmodyfikuj obydwa okna oknem Hamminga');
disp('komenda - np. dla wcos - hmmc=hc.*hamming(fp/fo)!;');
disp('UWAGA!! - W powyszej komendzie zamiast ! wstawi apostrof (transpozycja)');
disp('Wykrel charakterysyki filtrw zmodyfikowanych');
disp('Wyjanij, dlaczego Hmmc(0)>0 i Hmms(0)>0');
disp('Podpowied: Obejrzyj impz(hmmc) oraz impz(hmms)');disp(' ');
disp('Teraz moesz wykonywa swoje zadanie');
disp('Powrt do programu przez podanie komendy RETURN');
keyboard;
while 1;
fp=input('Czstotliwo prbkowania [Hz] fp=?');
h=input('Wspczynniki filtru h=?');
spr=menu('O.K.?','Tak','Nie');
if spr==1;break;end;
end;
while 1;
[H,f]=freqz(h,1,512,fp);
subplot(2,1,1);
plot(f,abs(H),C(c));grid on;hold on;
xlabel('Czestotliwosc [Hz]');ylabel('Amplituda');
title('Charakterysyka amplitudowa i fazowa filtru');
subplot(2,1,2);
plot(f,(180/pi)*angle(H),C(c));grid on;hold on;
xlabel('Czestotliwosc [Hz]');ylabel('Faza [stopnie]');c=c+1;
if c==8;c=1;menu('Koniec palety kolorow! ','O.K.');end;
menu('Charakterystyka impulsowa','Dalej');
figure;
impz(h);grid;
title('Odpowiedz impulsowa filtru');
ylabel('Amplituda-(wspolcz.filtru');xlabel('Numer probki'); 
spr=menu('Zmieniasz czestotliwo prbkowania?','Tak','Nie');
if spr==2;close;break;end;
close;
fp=input('fp=?');
end;
while 1;
spr=menu('Wycierasz Figure No.1?','Tak','Nie');
if spr==1;clf;c=1;break;end;
break;end;
break;
end;
if spr1==2;break;end;
end;
if s==3;break;end;
figure;
while 1;
home;disp('Podaj dyskretne waroci charakterystyki czestotliwosciowej');
m=input('m=?');
wym=size(m);x=[0:1:wym(2)-1];
subplot(2,1,1);
plot(x,m);grid;hold on;
stem(x,m);hold off; 
title('Dyskretna ch-ka czestotl.');
ylabel('Amplituda');xlabel('Probki');
spr=menu('O.K.?','Tak','Nie');
if spr==1;break;end;
clf;
end;
F=ifft(m)
subplot(2,1,2);
stem(x,abs(F));grid;
title('Probki ciagu czasowego');
ylabel('Wartosc');xlabel('Numer probki');
menu('Dalej','O.K.');
close;
end;
while 1;
spr=menu('Numerujesz wykresy?','Tak','Nie');
if spr==2;break;end;
n=input('Liczba wykresw do ponumerowania n=');
menu('Teraz ustawiaj celownik w wybranych miejscach i "strza" mysza','Gotow ?','O.K.'); 
for k=1:n;gtext(num2str(k));end;
break;
end;



